import threading
from Vi import *
from Vo import *
from Info import *

class Push():
    VI = 0
    VO = 1
    IF = 2

    def __init__(self):
        self.sem_using = threading.Semaphore(1)
        self.sem_emp = threading.Semaphore(0)
        self.Q=[]
        self.observerList=[]
        self.thList = []
        self.setUpObserverList()
        self.setUpThread()
        self.PushTh=threading.Thread(target = self.run)

    def setUpObserverList(self):
        self.observerList.append(Vi(self))
        self.observerList.append(Vo(self))
        self.observerList.append(Info(self))

    def setUpThread(self):
        for ob in self.observerList:
            self.thList.append(threading.Thread(target=ob.run))

    def insertMSG(self,str):
        self.sem_using.acquire() 
        self.Q.append(str)
        print("--------------------in insert[%s]"%str)
        self.sem_using.release() 
        self.sem_emp.release() 

    def getMSG(self):
        self.sem_emp.acquire() 
        self.sem_using.acquire() 
        msg =self.Q[0]
        del self.Q[0]
        self.sem_using.release() 
        return msg

    def startTh(self):
        print("start")
        for th in self.thList:
            th.start()
    def run(self):
        self.startTh()
        cunt= 0
        while(True):
            cunt +=1
            print("in observer[%s]"%( self.getMSG()) )

            if cunt%10 ==0:
                self.observerList[self.VI].insertRQ("Test","photo")
                #self.observerList[self.VO].insertRQ("Test","voice")
                self.observerList[self.IF].insertRQ("Test","info")


if __name__ == "__main__":
    p=Push()
    p.PushTh.start()